
package org.eclipse.birt.report.engine.emitter.excel.layout;

import org.eclipse.birt.report.engine.content.IStyle;
import org.eclipse.birt.report.engine.emitter.excel.ExcelUtil;
import org.eclipse.birt.report.engine.ir.SimpleMasterPageDesign;

public class PageDef
{
	int width, contentwidth;
	int topmargin, bottommargin, leftmargin, rightmargin;
	int height, footerheight, headerheight;
	IStyle style;

	public PageDef( SimpleMasterPageDesign page, IStyle style )
	{
		parsePage( page );
		this.style = style;
	}

	private void parsePage( SimpleMasterPageDesign page)
	{
		this.width = ExcelUtil.convertDimensionType( page.getPageWidth( ), 0 );
		this.leftmargin = ExcelUtil.convertDimensionType( page.getLeftMargin( ),
				width );
		this.rightmargin = ExcelUtil.convertDimensionType(
				page.getRightMargin( ), width );
		this.contentwidth = width - leftmargin - rightmargin;

		this.height = ExcelUtil.convertDimensionType( page.getPageHeight( ), 0 );
		this.headerheight = ExcelUtil.convertDimensionType( page
				.getHeaderHeight( ), height );
		this.footerheight = ExcelUtil.convertDimensionType( page
				.getFooterHeight( ), height );

		this.topmargin = ExcelUtil.convertDimensionType(
				page.getTopMargin( ), height );
		this.bottommargin = ExcelUtil.convertDimensionType(
				page.getBottomMargin( ), height );
		//TODO calculate the orientation
	}	
}
